//----------------------------------------------------------------------------
// SHA.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: SHA.pas
//----------------------------------------------------------------------------
#ifndef SHAHPP
#define SHAHPP
//----------------------------------------------------------------------------
#include <Dialogs.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Sha
{
//-- type declarations -------------------------------------------------------
typedef Byte TDigest[20];

typedef int TState[5];

struct TSHA_CTX
{
	int State[5];
	Cardinal Count;
	int Block[16];
} ;

enum THashType { htSHA1, htSHA };

class __declspec(delphiclass) TSHA;
class __declspec(pascalimplementation) TSHA : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	TSHA_CTX FContext;
	Byte DigestBits[20];
	bool DigestValid;
	int BlockIndex;
	THashType FHashType;
	void __fastcall NagRegister(void);
	void __fastcall Transform(void);
	int __fastcall Blk0(int i);
	int __fastcall Blk(int i);
	int __fastcall Rol(int value, int bits);
	void __fastcall R0(int * data, const int data_Size, int v, int w, int x, int y, int z, int i);
	void __fastcall R1(int * data, const int data_Size, int v, int w, int x, int y, int z, int i);
	void __fastcall R2(int * data, const int data_Size, int v, int w, int x, int y, int z, int i);
	void __fastcall R3(int * data, const int data_Size, int v, int w, int x, int y, int z, int i);
	void __fastcall R4(int * data, const int data_Size, int v, int w, int x, int y, int z, int i);
	
public:
	void __fastcall Init(void);
	void __fastcall HashByte(const Byte ByteToHash);
	void __fastcall HashString(const System::AnsiString StringToHash);
	void __fastcall HashFile(const System::AnsiString FileName);
	void __fastcall HashStream(Classes::TStream* const Stream);
	TDigest __fastcall Finish(void);
	System::AnsiString __fastcall GetHashString(void);
	System::AnsiString __fastcall GetVersion(void);
	
__published:
	__property THashType HashType = {read=FHashType, write=FHashType, nodefault};
public:
	/* TComponent.Create */ __fastcall virtual TSHA(Classes::TComponent* AOwner) : Classes::TComponent(
		AOwner) { }
	/* TComponent.Destroy */ __fastcall virtual ~TSHA(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall Register(void);

}	/* namespace Sha */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Sha;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SHA
